<?php

namespace Teknisa\TCO\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Tco00700TipoDePublico extends \Teknisa\GER\Controllers\TeknisaCrud {
    
    protected $novoCodigo;
    protected $crudService;
    protected $environment;
    protected $entityManager;
    protected $dataSourceManager;
    protected $dataSourceName = 'tipopublico';
    protected $service;

    public function __construct($crudService, $parameterBag, $environment, $entityManager, $novoCodigo, $dataSourceManager, $service) {
        $this->novoCodigo        = $novoCodigo;
        $this->crudService       = $crudService;
        $this->environment       = $environment;
        $this->entityManager     = $entityManager;
        $this->dataSourceManager = $dataSourceManager;
        $this->service           = $service;
    }
    
    public function salvaTipoPublico(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = 'tipopublico';
        
        $rows = $this->crudService->getRowsToSave($request, $this->dataSourceName);
        
        $filterCriteria = new FilterCriteria($this->dataSourceName);
        $filterCriteria->addCondition('CDTIPOPUBLICO', $rows[0]['CDTIPOPUBLICO']);
        $filterCriteria->addCondition('NRORG', $rows[0]['NRORG']);
        
        $dataSet = $this->dataSourceManager->findBy($filterCriteria);
        $codigo = $dataSet->getRows();
        
        if(strlen($rows[0]['CDTIPOPUBLICO']) !== 5){
            $message = array(
                'error' => 'Código inválido!'
            );
            $response->addDataSet(new DataSet ('result', $message));
            
        }else{
            
            if(!$codigo || $codigo[0]['NRTIPOPUBLICO'] == $rows[0]['NRTIPOPUBLICO']){
                if($rows[0]['__is_new']){
                    $rows[0]['NRTIPOPUBLICO'] = $this->novoCodigo->getCodeByTableName('TIPOPUBLICO', $this->environment->getNrOrgTrab());
                }
                $this->crudService->save($this->dataSourceName, $rows);
                $message = array(
                    'success' => 'Sucesso!',
                    'code'    => $rows[0]['NRTIPOPUBLICO']
                );
                $response->addDataSet(new DataSet ('result', $message));
            }else{
                
                $message = array(
                    'error' => 'Código já cadastrado!'
                );
                $response->addDataSet(new DataSet ('result', $message));
            }
        }
    }
    
    public function apagaTipoPublico(DTO\Request $request, DTO\Response $response) {
        $tiposPublico = $request->getDataSet()->getRows();
        $tiposPublicoUtilizados = $this->service->retornaTiposDePublicoUtilizados($tiposPublico); 
        
        if(empty($tiposPublicoUtilizados)){
            $rows = $this->crudService->getRowsToDelete($request, 'tipopublico');
            $dataSet = new DataSet('tipopublico', $rows);
    		$this->crudService->delete($response, $dataSet);
    		
            $response->addDataSet(new DataSet("tiposPublicoUtilizados", array()));
        } else {
            $response->addDataSet(new DataSet("tiposPublicoUtilizados", $tiposPublicoUtilizados));
        }
    }
}